## boost1.62 1.62.0+dfsg

=== libs/compute/CMakeLists.txt ===
# ---------------------------------------------------------------------------
#  Copyright (c) 2013 Kyle Lutz <kyle.r.lutz@gmail.com>
#
#  Distributed under the Boost Software License, Version 1.0
#  See accompanying file LICENSE_1_0.txt or copy at
#  http://www.boost.org/LICENSE_1_0.txt
#
# ---------------------------------------------------------------------------

cmake_minimum_required(VERSION 2.8)

project(BoostCompute)

set(CMAKE_MODULE_PATH ${BoostCompute_SOURCE_DIR}/cmake)
if (CMAKE_VERSION VERSION_LESS "3.1.0")
    list(APPEND CMAKE_MODULE_PATH "${BoostCompute_SOURCE_DIR}/cmake/opencl")
endif()

# find OpenCL
find_package(OpenCL REQUIRED)
include_directories(SYSTEM ${OpenCL_INCLUDE_DIRS})

# find Boost
find_package(Boost 1.54 REQUIRED)
include_directories(SYSTEM ${Boost_INCLUDE_DIRS})

# optional support for c++11
option(BOOST_COMPUTE_USE_CPP11 "Use C++11 features" OFF)
if(NOT MSVC)
  if(${BOOST_COMPUTE_USE_CPP11})
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++11")
  endif()
endif()

# optional support for offline-caching
option(BOOST_COMPUTE_USE_OFFLINE_CACHE "Use offline cache for OpenCL program binaries" OFF)
if(${BOOST_COMPUTE_USE_OFFLINE_CACHE})
  add_definitions(-DBOOST_COMPUTE_USE_OFFLINE_CACHE)
endif()

# thread-safety options
option(BOOST_COMPUTE_THREAD_SAFE "Compile with BOOST_COMPUTE_THREAD_SAFE defined" OFF)
if(${BOOST_COMPUTE_THREAD_SAFE})
  add_definitions(-DBOOST_COMPUTE_THREAD_SAFE)
  if(${BOOST_COMPUTE_USE_CPP11})
    if(MSVC)
      if (MSVC_VERSION GREATER 1800)
        add_definitions(-DBOOST_COMPUTE_HAVE_THREAD_LOCAL)
      endif()
    else()
      add_definitions(-DBOOST_COMPUTE_HAVE_THREAD_LOCAL)
    endif()
  endif()
endif()

# optional third-party libraries
option(BOOST_COMPUTE_HAVE_EIGEN "Have Eigen" OFF)
option(BOOST_COMPUTE_HAVE_OPENCV "Have OpenCV" OFF)
option(BOOST_COMPUTE_HAVE_QT "Have Qt" OFF)
option(BOOST_COMPUTE_HAVE_VTK "Have VTK" OFF)
option(BOOST_COMPUTE_HAVE_CUDA "Have CUDA" OFF)
option(BOOST_COMPUTE_HAVE_TBB "Have TBB" OFF)
option(BOOST_COMPUTE_HAVE_BOLT "Have BOLT" OFF)

include_directories(include)

if(${OpenCL_HEADER_CL_EXT_FOUND})
  add_definitions(-DBOOST_COMPUTE_HAVE_HDR_CL_EXT)
endif()

if(WIN32)
  # optional support for boost dynamic libraries
  option(BOOST_COMPUTE_BOOST_ALL_DYN_LINK "Use boost dynamic link libraries" OFF)
  if(${BOOST_COMPUTE_BOOST_ALL_DYN_LINK})
    add_definitions(-DBOOST_ALL_DYN_LINK)
  else()
    # for default use statis libs
    set(Boost_USE_STATIC_LIBS ON)
  endif()
  link_directories(${Boost_LIBRARY_DIRS})
endif()

# compiler options
option(BOOST_COMPUTE_ENABLE_COVERAGE "Enable code coverage generation" OFF)

# Visual Studio C++
if(MSVC)
  add_definitions(-D_CRT_SECURE_NO_WARNINGS)
  add_definitions(-D_SCL_SECURE_NO_WARNINGS)
  add_definitions(-DNOMINMAX)
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /bigobj")
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /wd4003") # Not enough actual parameters for a BOOST_PP macro
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /wd4244") # Warning C4244: 'initializing': conversion from 'double' to 'int', possible loss of data
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /wd4305") # Warning C4305: 'initializing': truncation from 'double' to 'float'
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /wd4800") # Warning C4800: 'uint32_t' : forcing value to bool 'true' or 'false' (performance warning)
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /wd4838") # Warning C4838: conversion from 'double' to 'float' requires a narrowing conversion
endif()

option(BOOST_COMPUTE_BUILD_TESTS "Build the Boost.Compute tests" OFF)
if(${BOOST_COMPUTE_BUILD_TESTS})
  enable_testing()
  add_subdirectory(test)
endif()

option(BOOST_COMPUTE_BUILD_BENCHMARKS "Build the Boost.Compute benchmarks" OFF)
if(${BOOST_COMPUTE_BUILD_BENCHMARKS})
  add_subdirectory(perf)
endif()

option(BOOST_COMPUTE_BUILD_EXAMPLES "Build the Boost.Compute examples" OFF)
if(${BOOST_COMPUTE_BUILD_EXAMPLES})
  add_subdirectory(example)
endif()

# configure cmake config file
configure_file(
  cmake/BoostComputeConfig.cmake.in
  ${BoostCompute_BINARY_DIR}/BoostComputeConfig.cmake
  @ONLY
)

# install cmake config file
install(
  FILES ${BoostCompute_BINARY_DIR}/BoostComputeConfig.cmake
  DESTINATION lib/cmake/BoostCompute
)

# install header files
install(DIRECTORY include/boost DESTINATION include/compute)

=== libs/python/SConstruct ===
# -*- python -*-
#
# Copyright (c) 2016 Stefan Seefeld
# All rights reserved.
#
# Distributed under the Boost Software License, Version 1.0.
# (See accompanying file LICENSE_1_0.txt or copy at
# http://www.boost.org/LICENSE_1_0.txt)

import SCons.Script.Main
import config
import config.ui
import platform
import os
import subprocess
import re

#
# We try to mimic the typical autotools-workflow.
#
# * In a 'configure' step all the essential build parameters are established
#   (either by explicit command-line arguments or from configure checks)
# * A subsequent build step can then simply read the cached variables, so
#   users don't have to memorize and re-issue the arguments on each subsequent
#   invocation, and neither do the config checks need to be re-run.
#
# The essential part here is to define a 'config' target, which removes any
# caches that may still be lingering around, then runs the checks.

if 'config' in COMMAND_LINE_TARGETS:
    # Clear the cache
    try: os.remove('bin.SCons/config.py')
    except: pass
if not os.path.exists('bin.SCons/'):
    os.mkdir('bin.SCons/')
vars = Variables('bin.SCons/config.py', ARGUMENTS)
config.add_options(vars)
arch = ARGUMENTS.get('arch', platform.machine())
env_vars = {}
if 'CXX' in os.environ: env_vars['CXX'] = os.environ['CXX']
if 'CXXFLAGS' in os.environ: env_vars['CXXFLAGS'] = os.environ['CXXFLAGS'].split()
env = Environment(toolpath=['config/tools'],
                  tools=['default', 'libs', 'tests', 'doc'],
                  variables=vars,
                  TARGET_ARCH=arch,
                  **env_vars)
if 'gcc' in env['TOOLS']:
    # Earlier SCons versions (~ 2.3.0) can't handle CXX=clang++.
    version = subprocess.check_output([env['CXX'], '--version'])
    match = re.search(r'[0-9]+(\.[0-9]+)+', version)
    if match:
        version = match.group(0)
    else:
        version = 'unknown'
    env['CXXVERSION'] = version

Help(config.ui.help(vars, env) + """
Variables are saved in bin.SCons/config.py and persist between scons invocations.
""")

if GetOption('help'):
    Return()

build_dir = config.prepare_build_dir(env)
config_log = '{}/config.log'.format(build_dir)

# configure
SConsignFile('{}/.sconsign'.format(build_dir))
#env.Decider('MD5-timestamp')
env.Decider('timestamp-newer')
checks = config.get_checks()
if 'config' in COMMAND_LINE_TARGETS:
    conf=env.Configure(custom_tests=checks, log_file=config_log, conf_dir=build_dir)
    if False in (getattr(conf, c)() for c in checks):
        Exit(1)
    env = conf.Finish()
    vars.Save('bin.SCons/config.py', env)

if not os.path.exists(config_log):
    print('Please run `scons config` first. (See `scons -h` for available options.)')
    Exit(1)

if not GetOption('verbose'):
    config.ui.pretty_output(env)    

# build
env['BPL_VERSION'] = '1.62'
for e in config.variants(env):
    variant_dir=e.subst("$BOOST_CURRENT_VARIANT_DIR")
    e.SConscript('src/SConscript', variant_dir=variant_dir + '/src',
                 exports = { 'env' : e.Clone(BOOST_LIB = 'python') })
    if 'test' in COMMAND_LINE_TARGETS:
        test_env = e.Clone(BOOST_LIB = 'python', BOOST_TEST = True)
        test_env.BoostUseLib('python')
        e.SConscript('test/SConscript', variant_dir=variant_dir + '/test',
                     exports = { 'env' : test_env })

if 'doc' in COMMAND_LINE_TARGETS:
    env.SConscript('doc/SConscript', variant_dir='bin.SCons/doc',
                   exports = { 'env' : e.Clone(BOOST_LIB = 'python') })

=== libs/compute/test/CMakeLists.txt ===
# ---------------------------------------------------------------------------
#  Copyright (c) 2013 Kyle Lutz <kyle.r.lutz@gmail.com>
#
#  Distributed under the Boost Software License, Version 1.0
#  See accompanying file LICENSE_1_0.txt or copy at
#  http://www.boost.org/LICENSE_1_0.txt
#
# ---------------------------------------------------------------------------

include_directories(../include)

set(BOOST_COMPONENTS unit_test_framework)

if(${BOOST_COMPUTE_USE_CPP11})
  # allow tests to use C++11 features
  add_definitions(-DBOOST_COMPUTE_USE_CPP11)
endif()

if (${BOOST_COMPUTE_USE_OFFLINE_CACHE})
  set(BOOST_COMPONENTS ${BOOST_COMPONENTS} system filesystem)
  add_definitions(-DBOOST_COMPUTE_USE_OFFLINE_CACHE)
endif()

if(${BOOST_COMPUTE_THREAD_SAFE} AND NOT ${BOOST_COMPUTE_USE_CPP11})
  set(BOOST_COMPONENTS ${BOOST_COMPONENTS} system thread)
endif()

if(MSVC AND BOOST_COMPONENTS)
  set(BOOST_COMPONENTS ${BOOST_COMPONENTS} chrono)
endif()

if(BOOST_COMPONENTS)
  list(REMOVE_DUPLICATES BOOST_COMPONENTS)
endif()
find_package(Boost 1.54 REQUIRED COMPONENTS ${BOOST_COMPONENTS})

if(NOT MSVC)
  add_definitions(-DBOOST_TEST_DYN_LINK)
else()
  if(MSVC AND ${BOOST_COMPUTE_BOOST_ALL_DYN_LINK})
      add_definitions(-DBOOST_TEST_DYN_LINK)
  endif()
endif()

# enable automatic kernel compilation error messages for tests
add_definitions(-DBOOST_COMPUTE_DEBUG_KERNEL_COMPILATION)

# enable code coverage generation (only with GCC for now)
if(${BOOST_COMPUTE_ENABLE_COVERAGE} AND "${CMAKE_CXX_COMPILER_ID}" STREQUAL "GNU")
  add_definitions(-fprofile-arcs -ftest-coverage)
endif()

function(add_compute_test TEST_NAME TEST_SOURCE)
  get_filename_component(TEST_TARGET ${TEST_SOURCE} NAME_WE)
  add_executable(${TEST_TARGET} ${TEST_SOURCE})
  target_link_libraries(${TEST_TARGET}
    ${OpenCL_LIBRARIES}
    ${Boost_LIBRARIES}
  )

  # link with coverage library
  if(${BOOST_COMPUTE_ENABLE_COVERAGE} AND "${CMAKE_CXX_COMPILER_ID}" STREQUAL "GNU")
    target_link_libraries(${TEST_TARGET} -fprofile-arcs -ftest-coverage)
  endif()

  add_test(${TEST_NAME} ${TEST_TARGET})
endfunction()

add_compute_test("core.buffer" test_buffer.cpp)
add_compute_test("core.closure" test_closure.cpp)
add_compute_test("core.command_queue" test_command_queue.cpp)
add_compute_test("core.context" test_context.cpp)
add_compute_test("core.device" test_device.cpp)
add_compute_test("core.event" test_event.cpp)
add_compute_test("core.function" test_function.cpp)
add_compute_test("core.kernel" test_kernel.cpp)
add_compute_test("core.pipe" test_pipe.cpp)
add_compute_test("core.platform" test_platform.cpp)
add_compute_test("core.program" test_program.cpp)
add_compute_test("core.system" test_system.cpp)
add_compute_test("core.type_traits" test_type_traits.cpp)
add_compute_test("core.user_event" test_user_event.cpp)

add_compute_test("utility.extents" test_extents.cpp)
add_compute_test("utility.invoke" test_invoke.cpp)
add_compute_test("utility.program_cache" test_program_cache.cpp)
add_compute_test("utility.wait_list" test_wait_list.cpp)

add_compute_test("algorithm.accumulate" test_accumulate.cpp)
add_compute_test("algorithm.adjacent_difference" test_adjacent_difference.cpp)
add_compute_test("algorithm.adjacent_find" test_adjacent_find.cpp)
add_compute_test("algorithm.any_all_none_of" test_any_all_none_of.cpp)
add_compute_test("algorithm.binary_search" test_binary_search.cpp)
add_compute_test("algorithm.copy" test_copy.cpp)
add_compute_test("algorithm.copy_type_mismatch" test_copy_type_mismatch.cpp)
add_compute_test("algorithm.copy_if" test_copy_if.cpp)
add_compute_test("algorithm.count" test_count.cpp)
add_compute_test("algorithm.equal" test_equal.cpp)
add_compute_test("algorithm.equal_range" test_equal_range.cpp)
add_compute_test("algorithm.extrema" test_extrema.cpp)
add_compute_test("algorithm.fill" test_fill.cpp)
add_compute_test("algorithm.find" test_find.cpp)
add_compute_test("algorithm.find_end" test_find_end.cpp)
add_compute_test("algorithm.for_each" test_for_each.cpp)
add_compute_test("algorithm.gather" test_gather.cpp)
add_compute_test("algorithm.generate" test_generate.cpp)
add_compute_test("algorithm.includes" test_includes.cpp)
add_compute_test("algorithm.inner_product" test_inner_product.cpp)
add_compute_test("algorithm.inplace_merge" test_inplace_merge.cpp)
add_compute_test("algorithm.inplace_reduce" test_inplace_reduce.cpp)
add_compute_test("algorithm.insertion_sort" test_insertion_sort.cpp)
add_compute_test("algorithm.iota" test_iota.cpp)
add_compute_test("algorithm.is_permutation" test_is_permutation.cpp)
add_compute_test("algorithm.is_sorted" test_is_sorted.cpp)
add_compute_test("algorithm.merge_sort_gpu" test_merge_sort_gpu.cpp)
add_compute_test("algorithm.merge" test_merge.cpp)
add_compute_test("algorithm.mismatch" test_mismatch.cpp)
add_compute_test("algorithm.next_permutation" test_next_permutation.cpp)
add_compute_test("algorithm.nth_element" test_nth_element.cpp)
add_compute_test("algorithm.partial_sum" test_partial_sum.cpp)
add_compute_test("algorithm.partition" test_partition.cpp)
add_compute_test("algorithm.partition_point" test_partition_point.cpp)
add_compute_test("algorithm.prev_permutation" test_prev_permutation.cpp)
add_compute_test("algorithm.radix_sort" test_radix_sort.cpp)
add_compute_test("algorithm.radix_sort_by_key" test_radix_sort_by_key.cpp)
add_compute_test("algorithm.random_fill" test_random_fill.cpp)
add_compute_test("algorithm.random_shuffle" test_random_shuffle.cpp)
add_compute_test("algorithm.reduce" test_reduce.cpp)
add_compute_test("algorithm.reduce_by_key" test_reduce_by_key.cpp)
add_compute_test("algorithm.remove" test_remove.cpp)
add_compute_test("algorithm.replace" test_replace.cpp)
add_compute_test("algorithm.reverse" test_reverse.cpp)
add_compute_test("algorithm.rotate" test_rotate.cpp)
add_compute_test("algorithm.rotate_copy" test_rotate_copy.cpp)
add_compute_test("algorithm.scan" test_scan.cpp)
add_compute_test("algorithm.scatter" test_scatter.cpp)
add_compute_test("algorithm.scatter_if" test_scatter_if.cpp)
add_compute_test("algorithm.search" test_search.cpp)
add_compute_test("algorithm.search_n" test_search_n.cpp)
add_compute_test("algorithm.set_difference" test_set_difference.cpp)
add_compute_test("algorithm.set_intersection" test_set_intersection.cpp)
add_compute_test("algorithm.set_symmetric_difference" test_set_symmetric_difference.cpp)
add_compute_test("algorithm.set_union" test_set_union.cpp)
add_compute_test("algorithm.sort" test_sort.cpp)
add_compute_test("algorithm.sort_by_key" test_sort_by_key.cpp)
add_compute_test("algorithm.stable_partition" test_stable_partition.cpp)
add_compute_test("algorithm.stable_sort" test_stable_sort.cpp)
add_compute_test("algorithm.stable_sort_by_key" test_stable_sort_by_key.cpp)
add_compute_test("algorithm.transform" test_transform.cpp)
add_compute_test("algorithm.transform_if" test_transform_if.cpp)
add_compute_test("algorithm.transform_reduce" test_transform_reduce.cpp)
add_compute_test("algorithm.unique" test_unique.cpp)
add_compute_test("algorithm.unique_copy" test_unique_copy.cpp)
add_compute_test("algorithm.lexicographical_compare" test_lexicographical_compare.cpp)

add_compute_test("allocator.buffer_allocator" test_buffer_allocator.cpp)
add_compute_test("allocator.pinned_allocator" test_pinned_allocator.cpp)

add_compute_test("async.wait" test_async_wait.cpp)
add_compute_test("async.wait_guard" test_async_wait_guard.cpp)

add_compute_test("container.array" test_array.cpp)
add_compute_test("container.dynamic_bitset" test_dynamic_bitset.cpp)
add_compute_test("container.flat_map" test_flat_map.cpp)
add_compute_test("container.flat_set" test_flat_set.cpp)
add_compute_test("container.mapped_view" test_mapped_view.cpp)
add_compute_test("container.stack" test_stack.cpp)
add_compute_test("container.string" test_string.cpp)
add_compute_test("container.valarray" test_valarray.cpp)
add_compute_test("container.vector" test_vector.cpp)

add_compute_test("exception.context_error" test_context_error.cpp)
add_compute_test("exception.no_device_found" test_no_device_found.cpp)
add_compute_test("exception.opencl_error" test_opencl_error.cpp)
add_compute_test("exception.unsupported_extension" test_unsupported_extension.cpp)

add_compute_test("functional.as" test_functional_as.cpp)
add_compute_test("functional.bind" test_functional_bind.cpp)
add_compute_test("functional.convert" test_functional_convert.cpp)
add_compute_test("functional.get" test_functional_get.cpp)
add_compute_test("functional.hash" test_functional_hash.cpp)
add_compute_test("functional.identity" test_functional_identity.cpp)
add_compute_test("functional.popcount" test_functional_popcount.cpp)
add_compute_test("functional.unpack" test_functional_unpack.cpp)

add_compute_test("image.image1d" test_image1d.cpp)
add_compute_test("image.image2d" test_image2d.cpp)
add_compute_test("image.image3d" test_image3d.cpp)
add_compute_test("image.image_sampler" test_image_sampler.cpp)

add_compute_test("iterator.buffer_iterator" test_buffer_iterator.cpp)
add_compute_test("iterator.constant_iterator" test_constant_iterator.cpp)
add_compute_test("iterator.counting_iterator" test_counting_iterator.cpp)
add_compute_test("iterator.discard_iterator" test_discard_iterator.cpp)
add_compute_test("iterator.function_input_iterator" test_function_input_iterator.cpp)
add_compute_test("iterator.permutation_iterator" test_permutation_iterator.cpp)
add_compute_test("iterator.strided_iterator" test_strided_iterator.cpp)
add_compute_test("iterator.transform_iterator" test_transform_iterator.cpp)
add_compute_test("iterator.zip_iterator" test_zip_iterator.cpp)

add_compute_test("memory.local_buffer" test_local_buffer.cpp)
add_compute_test("memory.svm_ptr" test_svm_ptr.cpp)

add_compute_test("random.bernoulli_distribution" test_bernoulli_distribution.cpp)
add_compute_test("random.discrete_distribution" test_discrete_distribution.cpp)
add_compute_test("random.linear_congruential_engine" test_linear_congruential_engine.cpp)
add_compute_test("random.mersenne_twister_engine" test_mersenne_twister_engine.cpp)
add_compute_test("random.threefry_engine" test_threefry_engine.cpp)
add_compute_test("random.normal_distribution" test_normal_distribution.cpp)
add_compute_test("random.uniform_int_distribution" test_uniform_int_distribution.cpp)
add_compute_test("random.uniform_real_distribution" test_uniform_real_distribution.cpp)

add_compute_test("types.fundamental" test_types.cpp)
add_compute_test("types.complex" test_complex.cpp)
add_compute_test("types.pair" test_pair.cpp)
add_compute_test("types.tuple" test_tuple.cpp)
add_compute_test("types.struct" test_struct.cpp)

add_compute_test("type_traits.result_of" test_result_of.cpp)

add_compute_test("experimental.clamp_range" test_clamp_range.cpp)
add_compute_test("experimental.malloc" test_malloc.cpp)
add_compute_test("experimental.sort_by_transform" test_sort_by_transform.cpp)
add_compute_test("experimental.tabulate" test_tabulate.cpp)

# miscellaneous tests
add_compute_test("misc.amd_cpp_kernel_language" test_amd_cpp_kernel_language.cpp)
add_compute_test("misc.lambda" test_lambda.cpp)
add_compute_test("misc.user_defined_types" test_user_defined_types.cpp)
add_compute_test("misc.literal_conversion" test_literal_conversion.cpp)

# extra tests (interop tests, linkage tests, etc.)
add_subdirectory(extra)

=== libs/hana/example/CMakeLists.txt ===
# Copyright Louis Dionne 2013-2016
# Distributed under the Boost Software License, Version 1.0.
# (See accompanying file LICENSE.md or copy at http://boost.org/LICENSE_1_0.txt)

##############################################################################
# Setup custom functions and master targets for the examples
##############################################################################
add_custom_target(examples COMMENT "Build all the examples.")
add_dependencies(check examples)

# Several examples have unused parameters because the name of the parameters
# are useful for illustration, even if the implementation is not actually
# presented. We don't want to generate warnings for that or need to comment
# out all unused parameter names.
boost_hana_append_flag(BOOST_HANA_HAS_WNO_UNUSED_PARAMETER -Wno-unused-parameter)


##############################################################################
# Caveats: Take note of examples that are not supported.
##############################################################################
if (NOT Boost_FOUND)
    list(APPEND EXCLUDED_EXAMPLES
        "ext/boost/*.cpp"
        "tutorial/appendix_mpl.cpp"
        "tutorial/ext/fusion_to_hana.cpp"
        "tutorial/ext/mpl_vector.cpp"
        "tutorial/integral.cpp"
        "tutorial/introduction.cpp"
        "tutorial/mpl_cheatsheet.cpp"
        "tutorial/quadrants.cpp"
        "tutorial/quickstart.switchAny.cpp"
        "tutorial/rationale.container.cpp"
        "tutorial/type.cpp"
        "type/basic_type.cpp"
    )
endif()


##############################################################################
# Add all the examples
##############################################################################
file(GLOB_RECURSE EXAMPLES "*.cpp")
file(GLOB_RECURSE EXCLUDED_EXAMPLES ${EXCLUDED_EXAMPLES})
list(REMOVE_ITEM EXAMPLES "" ${EXCLUDED_EXAMPLES})

foreach(_file IN LISTS EXAMPLES)
    boost_hana_target_name_for(_target "${_file}")
    add_executable(${_target} EXCLUDE_FROM_ALL "${_file}")
    boost_hana_add_test(${_target} ${CMAKE_CURRENT_BINARY_DIR}/${_target})
    add_dependencies(examples ${_target})
endforeach()

=== libs/test/build/CMakeLists.txt ===
# Copyright 2001, Raffi Enficiaud

# Use, modification, and distribution are subject to the
# Boost Software License, Version 1.0. (See accompanying file
# LICENSE_1_0.txt or copy at http://www.boost.org/LICENSE_1_0.txt)
#
# See http://www.boost.org/libs/test for the library home page.

cmake_minimum_required(VERSION 2.8.11)
project(BoostTest)

set_property(GLOBAL PROPERTY USE_FOLDERS ON)
set(CMAKE_MACOSX_RPATH ON)

add_definitions(-DBOOST_TEST_NO_LIB)

# build type, by default to release (with optimisations) 
if(NOT CMAKE_BUILD_TYPE AND NOT CMAKE_CONFIGURATION_TYPES)
  message(STATUS "Setting build type to 'Release' as none was specified.")
  set(CMAKE_BUILD_TYPE Release CACHE STRING "Choose the type of build." FORCE)
  # Set the possible values of build type for cmake-gui
  set_property(CACHE CMAKE_BUILD_TYPE PROPERTY STRINGS "Debug" "Release" "MinSizeRel" "RelWithDebInfo")
endif()

if(NOT WITHOUT_TESTS)
  # ctest sets BUILD_TESTING automatically, but does not seem to serve its purpose.
  include(CTest)
  enable_testing()
endif()


include(CheckCXXCompilerFlag)
include(CheckIncludeFileCXX)

if(NOT MSVC)
  # c++11 options
  check_cxx_compiler_flag(-std=c++11 HAS_CXX11_FLAG)
  check_cxx_compiler_flag(-std=c++0x HAS_CXX0X_FLAG)
  if(HAS_CXX11_FLAG)
    message(STATUS "Compiling with C++11 support")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++11")
  elseif(HAS_CXX0X_FLAG)
    #set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++0x")
  endif()
endif()

if(MSVC)
  add_definitions(-D_SCL_SECURE_NO_WARNINGS -D_CRT_SECURE_NO_WARNINGS)
  set(MSVC_Additional_flags "/fp:fast /GF /Oy /GT /Ox /Ob2 /Oi /Os")
  set(CMAKE_CXX_FLAGS_RELEASE "${CMAKE_CXX_FLAGS_RELEASE} ${MSVC_Additional_flags}")
endif()





# global path
set(BOOST_TEST_ROOT_DIR ${BoostTest_SOURCE_DIR}/..)
set(BOOST_ROOT_DIR ${BOOST_TEST_ROOT_DIR}/../..)
get_filename_component(BOOST_TEST_ROOT_DIR_ABS ${BoostTest_SOURCE_DIR}/.. ABSOLUTE)
get_filename_component(BOOST_ROOT_DIR_ABS ${BOOST_ROOT_DIR} ABSOLUTE)

# global include on boost
include_directories(${BOOST_ROOT_DIR_ABS}/)

# include globs
file(GLOB_RECURSE
     BOOST_UTF_HEADERS
     ${BOOST_TEST_ROOT_DIR}/include/*.hpp
     ${BOOST_TEST_ROOT_DIR}/include/*.ipp)

# organize files
foreach(_h IN LISTS BOOST_UTF_HEADERS)
  get_filename_component(_hh ${_h} ABSOLUTE)
  file(RELATIVE_PATH _v ${BOOST_TEST_ROOT_DIR_ABS}/include/boost/test ${_hh})
  get_filename_component(_v "${_v}" DIRECTORY)
  string(REPLACE "/" "\\" _v "${_v}")
  source_group(${_v} FILES ${_h})
endforeach()

set(BOOST_UTF_SRC
    ${BOOST_TEST_ROOT_DIR}/src/compiler_log_formatter.cpp

    ${BOOST_TEST_ROOT_DIR}/src/debug.cpp
    ${BOOST_TEST_ROOT_DIR}/src/decorator.cpp
    ${BOOST_TEST_ROOT_DIR}/src/execution_monitor.cpp
    ${BOOST_TEST_ROOT_DIR}/src/framework.cpp
    ${BOOST_TEST_ROOT_DIR}/src/junit_log_formatter.cpp
    ${BOOST_TEST_ROOT_DIR}/src/plain_report_formatter.cpp
    ${BOOST_TEST_ROOT_DIR}/src/progress_monitor.cpp
    ${BOOST_TEST_ROOT_DIR}/src/results_collector.cpp
    ${BOOST_TEST_ROOT_DIR}/src/results_reporter.cpp
    ${BOOST_TEST_ROOT_DIR}/src/test_tools.cpp
    ${BOOST_TEST_ROOT_DIR}/src/test_tree.cpp
    ${BOOST_TEST_ROOT_DIR}/src/unit_test_log.cpp
    ${BOOST_TEST_ROOT_DIR}/src/unit_test_main.cpp
    ${BOOST_TEST_ROOT_DIR}/src/unit_test_monitor.cpp
    ${BOOST_TEST_ROOT_DIR}/src/unit_test_parameters.cpp
    ${BOOST_TEST_ROOT_DIR}/src/xml_log_formatter.cpp
    ${BOOST_TEST_ROOT_DIR}/src/xml_report_formatter.cpp
    )

add_library(boost_test_framework
            STATIC
            ${BOOST_UTF_HEADERS}
            ${BOOST_UTF_SRC})
target_compile_definitions(boost_test_framework PUBLIC "-DBOOST_TEST_DYN_LINK=0")
target_include_directories(boost_test_framework PUBLIC ${BOOST_TEST_ROOT_DIR}/include/)
set_target_properties(boost_test_framework PROPERTIES FOLDER "UTF")


####
# Documentation files (files only, no target)
file(GLOB_RECURSE
     BOOST_UTF_DOC_FILES
     ${BOOST_TEST_ROOT_DIR}/doc/*.qbk)
add_custom_target(
  quickbook
  SOURCES ${BOOST_UTF_DOC_FILES})
set_property(TARGET quickbook PROPERTY FOLDER "Documentation/")


####
# Unit tests

# documentation tests
file(GLOB_RECURSE
     BOOST_UTF_DOC_EXAMPLES
     ${BOOST_TEST_ROOT_DIR}/doc/examples/*.cpp)

foreach(_h IN LISTS BOOST_UTF_DOC_EXAMPLES)
  get_filename_component(_hh ${_h} NAME_WE)
  add_executable(${_hh} ${_h} ${BOOST_TEST_ROOT_DIR}/doc/examples/${_hh}.output)
  target_include_directories(${_hh} PUBLIC ${BOOST_TEST_ROOT_DIR}/include/)
  set_target_properties(${_hh} PROPERTIES FOLDER "Doc examples")

  add_test(NAME doc-${_hh}
           COMMAND ${_hh})
  get_filename_component(_ext ${_h} EXT)
  string(FIND ${_ext} "fail" _index_fail)
  if(${_index_fail} GREATER -1)
    message(STATUS "test ${_hh}.${_ext} = ${_index_fail}")
    set_tests_properties(doc-${_hh} PROPERTIES WILL_FAIL TRUE)
  endif()
endforeach()


# unit tests folder
set(BOOST_TEST_UNITTESTS_FOLDER ${BOOST_TEST_ROOT_DIR}/test)

# datasets
file(GLOB
     BOOST_TEST_UNITTESTS_DATASET
     ${BOOST_TEST_UNITTESTS_FOLDER}/test-organization-ts/datasets-test/*.cpp
     ${BOOST_TEST_UNITTESTS_FOLDER}/test-organization-ts/datasets-test/*.hpp)
add_executable(boost_test_datasets ${BOOST_TEST_UNITTESTS_DATASET})
target_include_directories(boost_test_datasets PUBLIC ${BOOST_TEST_ROOT_DIR}/include/)
target_link_libraries(boost_test_datasets boost_test_framework)
target_compile_definitions(boost_test_datasets PUBLIC "BOOST_TEST_DYN_LINK=1")
set_target_properties(boost_test_datasets PROPERTIES FOLDER "Unit tests")
add_test(NAME bt-unittest-dataset
         COMMAND boost_test_datasets)


####
# TS writing-test-ts

set(BOOST_UTF_TESTS_IND_FILES
    writing-test-ts
    execution_monitor-ts
    framework-ts
    usage-variants-ts
    utils-ts
    test-organization-ts)
    

foreach(_ts IN LISTS BOOST_UTF_TESTS_IND_FILES)

  message("parsing test suite ${_ts}")
  file(GLOB
       _boost_utf_current_tsuite
       ${BOOST_TEST_UNITTESTS_FOLDER}/${_ts}/*.cpp)


  foreach(_h IN LISTS _boost_utf_current_tsuite)
    get_filename_component(_hh ${_h} ABSOLUTE)
    get_filename_component(_name ${_h} NAME_WE)
    file(RELATIVE_PATH _v ${BOOST_TEST_UNITTESTS_FOLDER} ${_hh})
    #get_filename_component(_v "${_v}" DIRECTORY)
    message("adding ${_ts}/${_name}")
    add_executable(${_name} ${_hh})
    target_link_libraries(${_name} PRIVATE boost_test_framework)
    set_target_properties(${_name} PROPERTIES FOLDER "Unit tests/${_ts}")
    add_test(NAME bt-unittest-${_name}
             COMMAND ${_name})
  endforeach()

  unset(_boost_utf_current_tsuite)

endforeach() # test suite

=== libs/numeric/odeint/examples/thrust/Makefile ===
# Copyright 2011-2014 Mario Mulansky
# Copyright 2011-2012 Karsten Ahnert
#
# Distributed under the Boost Software License, Version 1.0.
# (See accompanying file LICENSE_1_0.txt or
# copy at http://www.boost.org/LICENSE_1_0.txt)

# make sure BOOST_ROOT is pointing to your boost directory
# otherwise, set it here:
# BOOST_ROOT = /path/to/boost

# path to the cuda installation
CUDA_ROOT = /usr/local/cuda
# target architecture
ARCH = sm_13

NVCC = $(CUDA_ROOT)/bin/nvcc

INCLUDES += -I../../include/ -I$(BOOST_ROOT)

NVCCFLAGS = -O3 $(INCLUDES) -arch $(ARCH)

%.o : %.cu
	$(NVCC) $(NVCCFLAGS) -c $< -o $@

% : %.o
	$(NVCC) $(NVCCFLAGS) -o $@ $<


all : phase_oscillator_chain phase_oscillator_ensemble lorenz_parameters relaxation


clean :
	-rm *~ *.o phase_oscillator_chain phase_oscillator_ensemble lorenz_parameters relaxation

=== debian/changelog ===
boost1.62 (1.62.0+dfsg-10) unstable; urgency=medium

  * [e21ab62] Set gcc version 8 for the build.
  * [1886a38] Add dependency on g++-8.

 -- Anton Gladky <gladk@debian.org>  Fri, 14 Sep 2018 09:41:15 +0200

boost1.62 (1.62.0+dfsg-9) unstable; urgency=medium

  * [7809fdb] Drop dependency on libstdc++-4.8-dev. (Closes: #908732)
  * [c9ad4c1] Drop versioned dependency on g++-6. (Closes: #892390)

 -- Anton Gladky <gladk@debian.org>  Thu, 13 Sep 2018 22:40:44 +0200

boost1.62 (1.62.0+dfsg-8) unstable; urgency=medium

  * [85e2e8d] Add missing dependencies in python-autopkgtest
  * [d7ef962] Add missing deps (threads) in wave-autopkgtest
  * [1b25ec5] Add .gitlab-cy.yml to trigger autopkgtest in CI
  * [826e6fd] Add missing dependency in wave-test

 -- Anton Gladky <gladk@debian.org>  Sun, 15 Jul 2018 20:19:13 +0200

boost1.62 (1.62.0+dfsg-7) unstable; urgency=medium

  * [9b3650f] Add myself to uploaders
  * [2d088ce] Add initial autopkgtests

 -- Anton Gladky <gladk@debian.org>  Thu, 12 Jul 2018 19:14:00 +0200

boost1.62 (1.62.0+dfsg-6) unstable; urgency=medium

  * Fix building with Python 3.7 (closes: #902702).
  * Update Vcs-* fields after migration to git and to salsa.
  * Bump Standards-Version to 4.1.4.

 -- Giovanni Mascellani <gio@debian.org>  Sat, 30 Jun 2018 22:55:57 +0200

boost1.62 (1.62.0+dfsg-5.1) unstable; urgency=medium

  * Non-maintainer upload.
  * The rebuild against icu 60 changes some symbols as boost::regex
    embeds the icu version on them. Thus:
    - Build-depend on libicu-dev >= 60 to ensure we build with the new
      ABI.
    - Bump the shlibs version to ensure that rdeps that build against the
      new ABI get a minimum dependency on the shared lib.
    - Add breaks against packages built against the old ABI, so that those
      packages and libboost-regex are upgraded in lockstep.
    - All of the above closes: #898369.

 -- Emilio Pozuelo Monfort <pochu@debian.org>  Sat, 19 May 2018 16:35:58 +0200

boost1.62 (1.62.0+dfsg-5) unstable; urgency=medium

  * patches/flat-map-remove-partial-specializations.patch: New.  Upstream
    patch to remove now-unnecessary partial specializations.  Closes:
    #883987.

 -- Steve M. Robbins <smr@debian.org>  Sat, 06 Jan 2018 14:44:32 -0600

boost1.62 (1.62.0+dfsg-4) unstable; urgency=medium

  * New patch upstream-add-degree-reverse_graph.patch.

 -- Steve M. Robbins <smr@debian.org>  Sat, 12 Nov 2016 12:46:50 -0600

boost1.62 (1.62.0+dfsg-3) unstable; urgency=high

  * Build Boost.Python 2 & 3 bindings in separate builddirs. Closes: #842927

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Mon, 07 Nov 2016 18:44:37 +0000

boost1.62 (1.62.0+dfsg-2) unstable; urgency=medium

  * Limit boost-fiber packages to architectures it is built on.

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Thu, 20 Oct 2016 08:36:55 +0100

boost1.62 (1.62.0+dfsg-1) unstable; urgency=medium

  * New upstream 1.62.
  * Add packages for Boost.Fiber.
  * Drop package libboost1.62-dbg in favour of using automatic debug
    package generation.
  * Refresh patches.  Drop add-missing-list-include.patch -- applied upstream.

 -- Steve M. Robbins <smr@debian.org>  Sun, 16 Oct 2016 01:55:19 -0500

boost1.61 (1.61.0+dfsg-3) unstable; urgency=medium

  [ Dimitri John Ledkov ]
  * Actually bump standards version.

  [ Steve M. Robbins ]
  * Install /usr/bin/b2, the canonical name of bjam.  Closes: #831431.
  * libboost-iostreams1.61.0: remove Priority Important.  Closes: #829301.

 -- Steve M. Robbins <smr@debian.org>  Sat, 15 Oct 2016 10:59:14 -0500

boost1.61 (1.61.0+dfsg-2.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Upload to unstable.
  * Bump standards version.

 -- Matthias Klose <doko@debian.org>  Wed, 03 Aug 2016 21:10:58 +0200

boost1.61 (1.61.0+dfsg-2) experimental; urgency=high

  * Use DEB_HOST_GNU_TYPE for the compiler, because DEB_HOST_MULTIARCH is
    a lie - i386 port doesn't really exist, nor provides/uses i386
    compiler. Fixes FTBFS on i386.

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Wed, 03 Aug 2016 03:21:52 +0100

boost1.61 (1.61.0+dfsg-1) experimental; urgency=medium

  * New upstream release
  * Drop upstream cherrypicked patches, no longer needed
  * Update example files and sort them
  * Force use g++-6
  * Add python3:Depends for python packages (pacify dh_python3 warnings)
  * Drop python2.5 depends
  * Require icu 57 or better

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Mon, 01 Aug 2016 14:05:10 +0100

boost1.60 (1.60.0+dfsg-6) unstable; urgency=medium

  * patches/fix-ebo_functor_holder.patch: New. Compile fix for copy
    constructor (thanks, Graham Inggs).  Closes: #824021.

  * patches/add-missing-list-include.patch: New.  Add missing <list>
    include (thanks, Graham Inggs).  Closes: #824022.

 -- Steve M. Robbins <smr@debian.org>  Sun, 15 May 2016 23:38:50 -0500

boost1.60 (1.60.0+dfsg-5) unstable; urgency=medium

  [ Dimitri John Ledkov ]
  * Cherrypick upstream graph patch to fix ftbfs when adjacency_matrix.hpp
    template is used. Fixes FTBFS of sfcgal.

  [ Steve M. Robbins ]
  * patches/fix-auto-pointer-registration.patch: New.  Fixes auto-pointer
    registration in Boost.Python, affecting yade.  Closes: #823210.

 -- Steve M. Robbins <smr@debian.org>  Sat, 07 May 2016 22:23:17 -0500

boost1.60 (1.60.0+dfsg-4) unstable; urgency=medium

  * Fully enable context and coroutine on arm64, as it is available there.

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Fri, 22 Apr 2016 14:52:41 +0100

boost1.60 (1.60.0+dfsg-3) unstable; urgency=medium

  * Drop all the without/just mpi build logic, Ubuntu no longer needs it,
    as Archive Reorg is complete and packages in main can now build-depend
    on packages in universe (e.g. mpi). Boost can now be in-sync between
    Debian and Ubuntu.
  * Drop context/coroutine from arm64, not build there.
  * Arch qualify all context/coroutine dependencies such that we don't
    declare dependencies on non-existant packages.



=== debian/control ===
Source: boost1.62
Homepage: http://www.boost.org/
Section: libs
Priority: optional
Maintainer: Debian Boost Team <team+boost@tracker.debian.org>
Uploaders:
 Steve M. Robbins <smr@debian.org>,
 Giovanni Mascellani <gio@debian.org>,
 Anton Gladky <gladk@debian.org>
Build-Depends: debhelper (>= 9), dpkg-dev (>= 1.16.1~), dctrl-tools,
 zlib1g-dev, libbz2-dev, libicu-dev (>= 60), mpi-default-dev,
 bison, flex, docbook-to-man, help2man, xsltproc, doxygen, 
 dh-python,
 g++ (>= 4:5-0), g++-8,
 python, python-all-dev, 
 python3, python3-all-dev (>= 3.1)
Build-Conflicts: libopenmpi-dev (= 1.3.2-2)
Vcs-Browser: https://salsa.debian.org/debian/boost
Vcs-Git: https://salsa.debian.org/debian/boost.git -b 1.62.0
Standards-Version: 4.1.4

Package: libboost1.62-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: ${misc:Depends}, ${shlibs:Depends}, libstdc++-dev
Suggests: libboost1.62-doc,
 libboost-atomic1.62-dev,
 libboost-chrono1.62-dev,
 libboost-context1.62-dev [any-i386 any-amd64 armel armhf arm64 mips mipsel powerpc ppc64el],
 libboost-coroutine1.62-dev [any-i386 any-amd64 armel armhf arm64 mips mipsel powerpc ppc64el],
 libboost-date-time1.62-dev,
 libboost-exception1.62-dev,
 libboost-fiber1.62-dev [any-i386 any-amd64 armel armhf arm64 mips mipsel powerpc ppc64el],
 libboost-filesystem1.62-dev,
 libboost-graph1.62-dev,
 libboost-graph-parallel1.62-dev,
 libboost-iostreams1.62-dev,
 libboost-locale1.62-dev,
 libboost-log1.62-dev,
 libboost-math1.62-dev,
 libboost-mpi1.62-dev,
 libboost-mpi-python1.62-dev,
 libboost-program-options1.62-dev,
 libboost-python1.62-dev,
 libboost-random1.62-dev,
 libboost-regex1.62-dev,
 libboost-serialization1.62-dev,
 libboost-signals1.62-dev,
 libboost-system1.62-dev,
 libboost-test1.62-dev,
 libboost-thread1.62-dev,
 libboost-timer1.62-dev,
 libboost-type-erasure1.62-dev,
 libboost-wave1.62-dev,
 libboost1.62-tools-dev,
 libmpfrc++-dev, libntl-dev
Conflicts: bjam, boost-build, libboost1.42-dev, libboost1.46-dev, libboost1.48-dev, libboost1.49-dev, libboost1.50-dev, libboost1.52-dev, libboost1.53-dev, libboost1.54-dev, libboost1.55-dev, libboost1.57-dev, libboost1.58-dev, libboost1.60-dev, libboost1.61-dev
Description: Boost C++ Libraries development files
 The Boost web site provides free, peer-reviewed, portable C++ source
 libraries. The emphasis is on libraries which work well with the C++
 Standard Library. One goal is to establish "existing practice" and
 provide reference implementations so that the Boost libraries are
 suitable for eventual standardization. Some of the libraries have
 already been proposed for inclusion in the C++ Standards Committee's
 upcoming C++ Standard Library Technical Report.
 .
 This package provides headers for all Boost libraries.
 .
 Extended precision arithmetic package libmpfrc++-dev or libntl-dev is
 required to use the Boost.Multiprecision wrapping of the respective
 library.

Package: libboost1.62-tools-dev
Architecture: any
Multi-Arch: foreign
Section: libdevel
Depends: ${misc:Depends}, ${shlibs:Depends}
Suggests: xsltproc,
 doxygen,
 docbook-xml (>= 4.2),
 docbook-xsl (>= 1.73.2),
 default-jdk (>= 1.4),
 fop (>= 0.94)
Conflicts: bjam, boost-build, libboost1.49-dev, libboost1.53-tools-dev, libboost1.54-tools-dev, libboost1.55-tools-dev, libboost1.57-tools-dev, libboost1.58-tools-dev, libboost1.60-tools-dev, libboost1.61-tools-dev
Replaces: bjam, boost-build, libboost1.49-dev, libboost1.53-dev, libboost1.53-tools-dev
Description: Boost C++ Libraries development tools
 The Boost web site provides free, peer-reviewed, portable C++ source
 libraries. The emphasis is on libraries which work well with the C++
 Standard Library. One goal is to establish "existing practice" and
 provide reference implementations so that the Boost libraries are
 suitable for eventual standardization. Some of the libraries have
 already been proposed for inclusion in the C++ Standards Committee's
 upcoming C++ Standard Library Technical Report.
 .
 This package provides the auxiliary tools bjam, Boost.Build, bcp,
 inspect, boostbook and quickbook.

Package: libboost1.62-all-dev
Architecture: any
Section: libdevel
Depends: ${misc:Depends},
 libboost1.62-dev,
 libboost1.62-tools-dev,
 libboost-atomic1.62-dev,
 libboost-chrono1.62-dev,
 libboost-context1.62-dev [any-i386 any-amd64 armel armhf arm64 mips mipsel powerpc ppc64el],
 libboost-coroutine1.62-dev [any-i386 any-amd64 armel armhf arm64 mips mipsel powerpc ppc64el],
 libboost-date-time1.62-dev,
 libboost-exception1.62-dev,
 libboost-fiber1.62-dev [any-i386 any-amd64 armel armhf arm64 mips mipsel powerpc ppc64el],
 libboost-filesystem1.62-dev,
 libboost-graph1.62-dev,
 libboost-graph-parallel1.62-dev,
 libboost-iostreams1.62-dev,
 libboost-locale1.62-dev,
 libboost-log1.62-dev,
 libboost-math1.62-dev,
 libboost-mpi1.62-dev,
 libboost-mpi-python1.62-dev,
 libboost-program-options1.62-dev,
 libboost-python1.62-dev,
 libboost-random1.62-dev,
 libboost-regex1.62-dev,
 libboost-serialization1.62-dev,
 libboost-signals1.62-dev,
 libboost-system1.62-dev,
 libboost-test1.62-dev,
 libboost-thread1.62-dev,
 libboost-timer1.62-dev,
 libboost-type-erasure1.62-dev,
 libboost-wave1.62-dev
Description: Boost C++ Libraries development files (ALL)
 The Boost web site provides free, peer-reviewed, portable C++ source
 libraries. The emphasis is on libraries which work well with the C++
 Standard Library. One goal is to establish "existing practice" and
 provide reference implementations so that the Boost libraries are
 suitable for eventual standardization. Some of the libraries have
 already been proposed for inclusion in the C++ Standards Committee's
 upcoming C++ Standard Library Technical Report.
 .
 This metapackage provides the complete Boost development environment,
 including all separately-packaged libraries.

Package: libboost1.62-doc
Homepage: http://www.boost.org/libs/
Architecture: all
Section: doc
Depends: ${misc:Depends}
Suggests: libboost1.62-dev (>= ${source:Version})
Conflicts: libboost1.42-doc, libboost1.46-doc, libboost1.48-doc, libboost1.49-doc, libboost1.50-doc, libboost1.52-doc, libboost1.53-doc, libboost1.54-doc, libboost1.55-doc, libboost1.57-doc, libboost1.58-doc, libboost1.60-doc, libboost1.61-doc
Description: Boost.org libraries documentation
 The Boost web site provides free, peer-reviewed, portable C++ source
 libraries. The emphasis is on libraries which work well with the C++
 Standard Library. One goal is to establish "existing practice" and
 provide reference implementations so that the Boost libraries are
 suitable for eventual standardization. Some of the libraries have
 already been proposed for inclusion in the C++ Standards Committee's
 upcoming C++ Standard Library Technical Report.
 .
 This is documentation for the boost libraries in HTML format.
 Some pages point to header files provided in the corresponding -dev package,
 so it is suggested to install the latter as well.

Package: libboost-atomic1.62.0
Homepage: http://www.boost.org/libs/atomic/
Architecture: any
Multi-Arch: same
Section: libs
Depends: ${misc:Depends}, ${shlibs:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: atomic data types, operations, and memory ordering constraints
 This package forms part of the Boost C++ Libraries collection.
 .
 Boost.Atomic is a library that provides atomic data types and
 operations on these data types, as well as memory ordering
 constraints required for coordinating multiple threads through atomic
 variables. It implements the interface as defined by the C++11
 standard, but makes this feature available for platforms lacking
 system/compiler support for this particular C++11 feature.
 .
 Users of this library should already be familiar with concurrency in
 general, as well as elementary concepts such as "mutual exclusion".
 .
 The implementation makes use of processor-specific instructions where
 possible (via inline assembler, platform libraries or compiler
 intrinsics), and falls back to "emulating" atomic operations through
 locking.

Package: libboost-atomic1.62-dev
Homepage: http://www.boost.org/libs/atomic/
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: ${misc:Depends},
 libboost1.62-dev (= ${binary:Version}),
 libboost-atomic1.62.0 (= ${binary:Version})
Description: atomic data types, operations, and memory ordering constraints
 This package forms part of the Boost C++ Libraries collection.
 .
 Boost.Atomic is a library that provides atomic data types and
 operations on these data types, as well as memory ordering
 constraints required for coordinating multiple threads through atomic
 variables. It implements the interface as defined by the C++11
 standard, but makes this feature available for platforms lacking
 system/compiler support for this particular C++11 feature.
 .
 Users of this library should already be familiar with concurrency in
 general, as well as elementary concepts such as "mutual exclusion".
 .
 The implementation makes use of processor-specific instructions where
 possible (via inline assembler, platform libraries or compiler
 intrinsics), and falls back to "emulating" atomic operations through
 locking.
Conflicts: libboost-atomic1.53-dev, libboost-atomic1.54-dev, libboost-atomic1.55-dev, libboost-atomic1.57-dev, libboost-atomic1.58-dev, libboost-atomic1.60-dev, libboost-atomic1.61-dev

Package: libboost-chrono1.62.0
Homepage: http://www.boost.org/libs/chrono/
Architecture: any
Multi-Arch: same
Section: libs
Depends: ${misc:Depends}, ${shlibs:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: C++ representation of time duration, time point, and clocks
 This package forms part of the Boost C++ Libraries collection.
 .
 The Boost.Chrono library provides:
 .
  * A means to represent time durations: managed by the generic duration
    class.Examples of time durations include days, minutes, seconds and
    nanoseconds, which can be represented with a fixed number of clock
    ticks per unit. All of these units of time duration are united with
    a generic interface by the duration facility.
  * A type for representing points in time: time_point. A time_point
    represents an epoch plus or minus a duration. The library leaves
    epochs unspecified. A time_point is associated with a clock.
  * Several clocks, some of which may not be available on a particular
    platform: system_clock, steady_clock and high_resolution_clock. A
    clock is a pairing of a time_point and duration, and a function
    which returns a time_point representing now.
 .
 To make the timing facilities more generally useful, Boost.Chrono
 provides a number of clocks that are thin wrappers around the
 operating system's time APIs, thereby allowing the extraction of wall
 clock time, user CPU time, system CPU time spent by the process:
 .
  * process_real_cpu_clock, captures wall clock CPU time spent by the
    current process.
  * process_user_cpu_clock, captures user-CPU time spent by the current
    process.
  * process_system_cpu_clock, captures system-CPU time spent by the
    current process.
  * a tuple-like class process_cpu_clock, that captures real, user-CPU,
    and system-CPU process times together.
  * a thread_clock thread steady clock giving the time spent by the
    current thread (when supported by a platform).
 .
 Lastly, Boost.Chrono includes typeof registration for duration and
 time_point to permit using emulated auto with C++03 compilers.

Package: libboost-chrono1.62-dev
Homepage: http://www.boost.org/libs/chrono/
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: ${misc:Depends},
 libboost1.62-dev (= ${binary:Version}),
 libboost-chrono1.62.0 (= ${binary:Version})
Conflicts: libboost-chrono1.48-dev, libboost-chrono1.49-dev, libboost-chrono1.50-dev, libboost-chrono1.52-dev, libboost-chrono1.53-dev, libboost-chrono1.54-dev, libboost-chrono1.55-dev, libboost-chrono1.57-dev, libboost-chrono1.58-dev, libboost-chrono1.60-dev, libboost-chrono1.61-dev

=== debian/rules ===
#! /usr/bin/make -f

# Boost libraries for which we want separate packages
# context is conditionally compiled because it is not supported yet on several architectures
# coroutine, coroutine2, and fiber depend on context, so they are also conditionally compiled
boost_libs := atomic chrono date-time exception filesystem		\
              graph graph-parallel iostreams locale log math mpi	\
              mpi-python program-options python random regex		\
              serialization signals system test thread timer 		\
              type-erasure wave

# these are special cases, where /usr/lib name differs from Boost library name
boost_lib_log := log log_setup
boost_lib_math := math_c99 math_c99f math_tr1 math_tr1f
boost_lib_math_long_double := math_c99l math_tr1l
boost_lib_serialization := serialization wserialization
boost_lib_test := prg_exec_monitor test_exec_monitor unit_test_framework

pyversions = $(shell pyversions -rv) $(shell py3versions -rv)

# These are special cases for suffixes.  Generally come from --python-buildid, so begin with a dash.
boost_suffixes_python := $(addprefix -py,$(subst .,,$(pyversions)))
boost_suffixes_mpi-python := $(boost_suffixes_python)

# Files that are generated by filtering a template
filtered_files = 

DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk
include /usr/share/dpkg/architecture.mk

%:
	dh $@ --with python2 --with python3

override_dh_auto_configure: user-config.jam make-debhelper

override_dh_auto_build: $(bjam) debian/bjam.1
	$(JAM) $(JAM_WITHOUT) --without-python
	for pyver in $(pyversions); do \
	 	pyid=$$(echo $$pyver | tr -d .); \
		echo "Building Boost.Python for python version $$pyver"; \
	 	$(JAM) --build-dir=build-$$pyver --user-config=$(CURDIR)/user-config-$$pyver.jam --with-python --with-mpi --python-buildid=py$$pyid python=$$pyver; \
	 	mv stage/lib/mpi.so stage/lib/mpi-py$$pyid.so || true; \
	done

	cd $(bbv2dir) && ./bootstrap.sh --with-toolset=gcc
	cd tools/bcp && $(JAM)
	cd tools/inspect/build && $(JAM)
	cd tools/quickbook && $(JAM)
	cd libs/python/pyste/install && python setup.py build

testsuite:
	cd status && $(JAM) $(JAM_WITHOUT)

override_dh_auto_clean: clean-debhelper
	-cd tools && $(JAM) clean
	-$(JAM) clean
	-cd libs/python/pyste/install && python setup.py clean
	rm -rf libs/python/pyste/install/build
	rm -rf tools/jam/src/bootstrap
	rm -rf tools/jam/src/bin.*
	rm -ff tools/jam/src/bjam
	rm -rf tools/regression/build/bin
	rm -rf bin.v2 dist
	rm -rf user-config.jam
	rm -rf build-* user-config-*.jam
	rm -rf debian/bjam.1
	dh_auto_clean

override_dh_compress:
	dh_compress -Xlibboost$(PKGVERSION)-doc/HTML

override_dh_install:
	$(JAM) --prefix=$(CURDIR)/debian/tmp/usr $(JAM_WITHOUT) \
		--libdir=$(CURDIR)/debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH) \
		--without-python install
	for pyver in $(pyversions); do \
		pyid=`echo $$pyver | tr -d .`; \
		$(JAM) --build-dir=build-$$pyver --user-config=$(CURDIR)/user-config-$$pyver.jam --prefix=$(CURDIR)/debian/tmp/usr \
			--libdir=$(CURDIR)/debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH) \
			install --with-python --with-mpi --python-buildid=py$$pyid python=$$pyver; \
	done

	# Install Boost.Build v2 & jam
	cd $(bbv2dir) && ./bjam install --prefix=$(CURDIR)/debian/tmp/usr --libdir=$(CURDIR)/debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)
	mv debian/tmp/usr/share/boost-build/example debian/boost-build-examples

	find debian/tmp/usr/include debian/tmp/usr/share/boost-build -type f | xargs chmod 644
	find debian/tmp -name .cvsignore | xargs rm -f
	find debian -empty -type f | xargs rm -f

	# package libboost$(PKGVERSION)-dev
	dh_install -plibboost$(PKGVERSION)-dev \
	   debian/tmp/usr/include/boost \
	   usr/include
	dh_install -plibboost$(PKGVERSION)-tools-dev \
	   debian/tmp/usr/bin/bjam \
	   dist/bin/bcp \
	   dist/bin/inspect \
	   dist/bin/quickbook \
	   usr/bin
	dh_link -plibboost$(PKGVERSION)-tools-dev usr/bin/bjam usr/bin/b2
	dh_installman -plibboost$(PKGVERSION)-tools-dev debian/bjam.1 debian/bcp.1 debian/inspect.1 debian/quickbook.1
	dh_install -plibboost$(PKGVERSION)-tools-dev tools/boostbook/xsl/* usr/share/boostbook/xsl
	dh_install -plibboost$(PKGVERSION)-tools-dev tools/boostbook/dtd/* usr/share/boostbook/dtd
	dh_install -plibboost$(PKGVERSION)-tools-dev debian/tmp/usr/share/boost-build

	# package libboost-date-time$(PKGVERSION)-dev
	dh_installdocs -plibboost-date-time$(PKGVERSION)-dev libs/date_time/data

	# package libboost-doc
	rm -rf $(htmldir)
	mkdir -p $(htmldir) 
	#cat debian/documentation-files | xargs cp --parents --target-directory=$(htmldir)
	#find doc libs -name doc | xargs -n1 cp --archive --parents --target-directory=$(htmldir)
	rm -rf $(htmldir)/boost
	dh_link -plibboost$(PKGVERSION)-doc \
	   usr/include/boost \
	   usr/share/doc/libboost$(PKGVERSION)-doc/HTML/boost
	# provide a constant symlink to the latest documents and examples
	dh_link -plibboost$(PKGVERSION)-doc \
	   usr/share/doc/libboost$(PKGVERSION)-doc/HTML \
	   usr/share/doc/libboost-doc/HTML
	dh_link -plibboost$(PKGVERSION)-doc \
	   usr/share/doc/libboost$(PKGVERSION)-doc/examples \
	   usr/share/doc/libboost-doc/examples

	dh_link -plibboost-python$(PKGVERSION)-dev \
	   usr/lib/$(DEB_HOST_MULTIARCH)/libboost_python-py27.a \
	   usr/lib/$(DEB_HOST_MULTIARCH)/libboost_python.a
	dh_link -plibboost-python$(PKGVERSION)-dev \
	   usr/lib/$(DEB_HOST_MULTIARCH)/libboost_python-py27.so \
	   usr/lib/$(DEB_HOST_MULTIARCH)/libboost_python.so

	dh_link -plibboost-mpi-python$(PKGVERSION)-dev \
	   usr/lib/$(DEB_HOST_MULTIARCH)/libboost_mpi_python-py27.a \
	   usr/lib/$(DEB_HOST_MULTIARCH)/libboost_mpi_python.a
	dh_link -plibboost-mpi-python$(PKGVERSION)-dev \
	   usr/lib/$(DEB_HOST_MULTIARCH)/libboost_mpi_python-py27.so \
	   usr/lib/$(DEB_HOST_MULTIARCH)/libboost_mpi_python.so

	dh_installexamples -plibboost$(PKGVERSION)-doc debian/boost-build-examples
	mkdir -p $(exampledir)
	cat debian/example-files | xargs cp -a --parents --target-directory=$(exampledir)
	find $(exampledir) -type f | xargs chmod 644

	# package libboost-mpi-python$(SOVERSION)
	dh_install -plibboost-mpi-python$(SOVERSION)
	for pyver in $(pyversions); do \
		pyid=`echo $$pyver | tr -d .`; \
		case $$pyver in \
			2.*) pydistdir=usr/lib/python$$pyver/dist-packages/boost ;; \
			3.*) pydistdir=usr/lib/python3/dist-packages/boost ;; \
		esac; \
		dh_install -plibboost-mpi-python$(SOVERSION) libs/mpi/build/__init__.py $$pydistdir; \
		dh_installdirs -plibboost-mpi-python$(SOVERSION) $$pydistdir; \
		cp stage/lib/mpi-py$$pyid.so debian/libboost-mpi-python$(SOVERSION)/$$pydistdir/mpi.so || true; \
	done

	cd libs/python/pyste/install && python setup.py install --no-compile --prefix=$(pyste_prefix) --install-lib=$(pyste_prefix)/share/pyshared
	mv $(pyste_prefix)/bin/pyste.py $(pyste_prefix)/bin/pyste
	dh_installman -plibboost-python$(PKGVERSION)-dev debian/pyste.1

	dh_install --list-missing

override_dh_strip:
	dh_strip --dbgsym-migration='libboost1.55-dbg, libboost1.58-dbg, libboost1.61-dbg'

override_dh_makeshlibs:
	dh_makeshlibs -plibboost-regex1.62.0 -V 'libboost-regex1.62.0 (>= 1.62.0+dfsg-5.1)'
	dh_makeshlibs --remaining-packages

# set the number of build jobs
ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
  JOBS := -j$(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
endif

version_full := $(shell dpkg-parsechangelog | grep Version | cut -d' ' -f2)
version_upstream := $(shell echo $(version_full) | cut -d'+' -f1)
version_major := $(shell echo $(version_upstream) | cut -d'.' -f1,2)

PKGVERSION = $(version_major)
SOVERSION = $(version_upstream)


# Function to map Boost component name to set of shared library names
# Input: Boost component name
# Return: shared library names for the given Boost library
boost_lib = $(if $(boost_lib_$(1)), $(boost_lib_$(1)), $(1))

# Function to map Boost component name to set of suffixes for the library
# Input: Boost component name
# Return: suffixes for the given Boost component

=== debian/tests/control ===
Tests: atomic
Depends: libboost-atomic-dev, build-essential, cmake

Tests: chrono
Depends: libboost-chrono-dev, libboost-system-dev, build-essential, cmake

Tests: context
Depends: libboost-context-dev, build-essential, cmake

Tests: datetime
Depends: libboost-date-time-dev, build-essential, cmake

Tests: exception
Depends: libboost-exception-dev, build-essential, cmake
Restrictions: allow-stderr

Tests: fiber
Depends: libboost-fiber-dev, build-essential, cmake

Tests: filesystem
Depends: libboost-filesystem-dev, build-essential, cmake

Tests: graph
Depends: libboost-graph-dev, build-essential, cmake

Tests: graph-parallel
Depends: libboost-graph-parallel-dev, libboost-mpi-dev, libboost-system-dev, mpi-default-dev, build-essential, libgraph-easy-perl, cmake

Tests: iostreams
Depends: libboost-iostreams-dev, build-essential, cmake

Tests: locale
Depends: libboost-locale-dev, build-essential, cmake

Tests: log
Depends: libboost-log-dev, build-essential, cmake

Tests: math
Depends: libboost-math-dev, build-essential, cmake

Tests: mpi
Depends: libboost-mpi-dev, mpi-default-dev, build-essential, cmake

Tests: mpi-python
Depends: libboost-mpi-python-dev, mpi-default-dev, python-minimal

Tests: program-options
Depends: libboost-program-options-dev, build-essential, cmake

Tests: python
Depends: libboost-python-dev, python-minimal, cmake, build-essential, clang

Tests: random
Depends: libboost-random-dev, build-essential, cmake

Tests: regex
Depends: libboost-regex-dev, build-essential, cmake, html2text

Tests: serialization
Depends: libboost-serialization-dev, libboost-random-dev, build-essential, cmake

Tests: signals
Depends: libboost-signals-dev, build-essential, cmake

Tests: system
Depends: libboost-system-dev, build-essential, cmake
Restrictions: allow-stderr

Tests: test
Depends: libboost-test-dev, build-essential, cmake
Restrictions: allow-stderr

Tests: thread
Depends: libboost-thread-dev, build-essential, cmake

Tests: timer
Depends: libboost-timer-dev, build-essential, cmake

Tests: type-erasure
Depends: libboost-type-erasure-dev, build-essential, cmake

Tests: wave
Depends: libboost-wave-dev, libboost-thread-dev, build-essential, cmake
